/**
 * Items controller
 */
(function(angular, undefined) {
angular
	.module('autoinfo')

	.controller('CategoryController', [
		'$q',
		'$stateParams',
		'itemsService',
		'categoriesService',
		'$scope',
		'appConfig',
		'$ionicHistory',
    '$rootScope',
		function ($q, $stateParams, itemsSvc, categoriesSvc, $scope, appConfig,$ionicHistory,$rootScope) {
			'use strict';

			var vm = this,
				noMoreItemsAvailable = false;


			vm.items = [];
			vm.loadData = loadData;
			$scope.goBack = function() {
					    $ionicHistory.goBack();
					  };
			function loadData() {
				itemsSvc.getItems({
					'filters': {'cat': parseInt($stateParams.categoryId, 10)},
					'params': {'offset': vm.items.length, 'per_page': appConfig.maxItemsPaging}
				}).then(setItems);
			}

			categoriesSvc.getCategory(parseInt($stateParams.categoryId, 10)).then(setCategory);

			function setCategory(response) {
        console.error(response,'NEWS CATEGORY');
        $rootScope.main_title = response.type_name;
				vm.category = response;
			}

			function setItems(response) {
       // $rootScope.main_title = response.type_name;

				if (response.length === 0) {
					vm.noMoreItemsAvailable = true;
				} else {
					vm.items = vm.items.concat(response);
				}
				$scope.$broadcast('scroll.infiniteScrollComplete');
			}
		}
	]);

})(window.angular);
