/**
 * Items controller
 */
(function(angular, undefined) {
angular
	.module('autoinfo')

	.controller('ClubController', [
		'$q',
		'$stateParams',
		'clubsService',
		'categoriesService',
		'$scope',
		'appConfig',
		'$ionicHistory',
		'$window',
    '$http',
		'$ionicLoading',
		function ($q, $stateParams, itemsSvc, categoriesSvc, $scope, appConfig,$ionicHistory,$window,$http,$ionicLoading) {
			'use strict';

			var vm = this;



      $ionicLoading.show({
        content: 'Loading',
        animation: 'fade-in',
        showBackdrop: true,
        maxWidth: 200,
        showDelay: 0
      });




      itemsSvc.getItemById(parseInt($stateParams.itemId, 10))
        .then(setItems)
        .finally(function(){
          $ionicLoading.hide();
        });

      function setItems(response) {


        vm.item = response;


        /**
         * @property playlistOpen
         * @type {Boolean}
         * @default false
         */
        $scope.playlistOpen = false;

        /**
         * @property videos
         * @type {Object}
         */
        $scope.videos = [];


        return response;
      }



    }
	]);

})(window.angular);
