/**
 * Items controller
 */
(function(angular, undefined) {
angular
	.module('autoinfo')

	.controller('ClubsController', [
		'$q',
		'$stateParams',
		'clubsService',
		'categoriesService',
		'$scope',
		'appConfig',
		'$ionicHistory',
		'$window',
    '$http',
		function ($q, $stateParams, itemsSvc, categoriesSvc, $scope, appConfig,$ionicHistory,$window,$http) {
			'use strict';

			var vm = this,
				noMoreItemsAvailable = false;


			vm.items = [];
      vm.noMoreItemsAvailable = false;
			vm.loadData = loadData;
			$scope.goBack = function() {
					    $ionicHistory.goBack();
					  };




      $scope.model = {};
      $scope.model.userid = $window.localStorage.getItem(AI_USER_ID);
      $scope.model.regSelected = 0;

      $scope.model.edit_city = false;
      $http.get('data/citiesr.json').success(function (response) {
        //  console.log(,"city") ;
        $scope.model.cities = response;
        $scope.model.cities.unshift({name: LANG.SELECT_REGION, cities: []});
        $scope.model.city = parseInt($window.localStorage.getItem(AI_CITY));
        $scope.model.city_name = $window.localStorage.getItem(AI_CITY_NAME);


        var region = parseInt($window.localStorage.getItem('__CLUBS_REGION_ID'));
        var city = parseInt($window.localStorage.getItem('__CLUBS_CITY_ID'));
        region=region>0?region:0;
        city=city>0?city:0;

        for(var ii in $scope.model.cities){
          if(region ==$scope.model.cities[ii].region_id){
            $scope.model.regSelected =   $scope.model.cities[ii];
            for(var iii in $scope.model.cities[ii].cities) {
              if (city == $scope.model.cities[ii].cities[iii].city_id) {
                $scope.model.citySelected = $scope.model.cities[ii].cities[iii];
              }
            }

          }


        }

      });


      $scope.filterChange = function () {
        vm.items = [];
        vm.q = '';
        vm.region = parseInt($scope.model.regSelected.region_id);
        if(!!$scope.model.citySelected)
          vm.city = parseInt($scope.model.citySelected.city_id);
        else  vm.city = 0;
        $window.localStorage.setItem('__CLUBS_REGION_ID', (vm.region));
        $window.localStorage.setItem('__CLUBS_CITY_ID', (vm.city));
//          console.log(parseInt(vm.city));
        loadData(1);
      };

      function loadData(clear) {

        if (clear == 1) {
          vm.items = [];

        }


        vm.region = parseInt($window.localStorage.getItem('__CLUBS_REGION_ID'));


        vm.region = vm.region > 0  ? vm.region : 0;

        vm.city = parseInt($window.localStorage.getItem('__CLUBS_CITY_ID'));



        itemsSvc.getItems({
					'params': {'offset': vm.items.length, 'per_page': appConfig.maxItemsPaging,r: vm.region,c:vm.city }
				}).then(setItems);
			}
      Object.size = function(obj) {
        var size = 0,
          key;
        for (key in obj) {
          if (obj.hasOwnProperty(key)) size++;
        }
        return size;
      };

			function setItems(response) {
        response = response.items;
			  console.log((response),"response!!!");
        console.log(vm.noMoreItemsAvailable,"vm.noMoreItemsAvailable!!!");
				if (Object.size(response) === 0) {
					vm.noMoreItemsAvailable = true;
				} else {
					vm.items = vm.items.concat(response);
				}
				$scope.$broadcast('scroll.infiniteScrollComplete');
			}
		}
	]);

})(window.angular);
