/**
 * Items controller
 */
(function(angular, undefined) {
angular
	.module('autoinfo')

	.controller('PartnersController', [
		'$q',
		'$stateParams',
		'pitemsService',
		'pcategoriesService',
		'$ionicLoading',
		'sharedObjects',
		'$scope',
		'$ionicHistory',

		function ($q, $stateParams, itemsSvc, categoriesSvc,  $ionicLoading, sharedObjects,$scope,$ionicHistory) {
			'use strict';

			var vm = this;

			$ionicLoading.show({
				content: 'Loading',
				animation: 'fade-in',
				showBackdrop: true,
				maxWidth: 200,
				showDelay: 0
			});




			itemsSvc.getItemById(parseInt($stateParams.itemId, 10))
				.then(setItems)
				.then(getCategory)
				.then(setCategory)
				.then(setShare)
				.finally(function(){
					$ionicLoading.hide();
				});

			function setItems(response) {


				vm.item = response;


				/**
					             * @property playlistOpen
					             * @type {Boolean}
					             * @default false
					             */
					            $scope.playlistOpen = false;

					            /**
					             * @property videos
					             * @type {Object}
					             */
					            $scope.videos = [];


				return response;
			}

			function getCategory(response) {
				return categoriesSvc.getCategory(response.category);
			}

			function setCategory(response) {
				vm.category = response;
			}

			function setShare() {
				vm.share = {
					'networks': ['facebook', 'twitter', 'whatsapp', 'anywhere', 'sms', 'email'],
					'message': vm.item.title,
					'subject': vm.category.name,
					'file': vm.item.img,
					'link': vm.item.link,
					'toArr': ['info@.ru'],
					'bccArr': [],
					'ccArr': [],
					'phone': '098765432'
				};
			}

		}
	]);

})(window.angular);
