/**
 * Page controller
 */
(function(angular, undefined) {
  angular
    .module('autoinfo')

    .controller('testController', [
      '$scope',
      '$stateParams',
      'pagesService',
      '$rootScope',
      '$window',
      'ionicDatePicker',
      '$jrCrop',
'$ionicModal',
      '$ionicLoading',
      function ($scope, $stateParams, pagesSvc,$rootScope,$window,ionicDatePicker,$jrCrop,$ionicModal,$ionicLoading) {
        'use strict';

        $scope.myImage='';
        $scope.myCroppedImage='';

        $scope.crop = function(url) {
          $jrCrop.crop({
            url: url,
            width: 400,
            height: 300
          }).then(function(canvas) {
            console.log(canvas);
            var image = canvas.toDataURL();

            console.log(image);
            $scope.myCroppedImage= image;
            //var image is the result, you can show it using : $scope.pictureUrl = image;
          }, function() {
            // User canceled or couldn't load image.
          });
        };


        $scope.imgCrop = '';

        //Rotate Image
        $scope.rotate = function() {
          $('#newUpload').cropper('rotate', 90);
          $scope.croppedImg = $('#newUpload').cropper('getCroppedCanvas', { width: 500, height: 500 }).toDataURL("image/jpeg", 1.0);
        };

        //Zoom Image
        $scope.zoomIn = function() {
          $('#newUpload').cropper('zoom', 0.1);
          $scope.croppedImg = $('#newUpload').cropper('getCroppedCanvas', { width: 500, height: 500 }).toDataURL("image/jpeg", 1.0);
        };

        $scope.zoomOut = function() {
          $('#newUpload').cropper('zoom', -0.1);
          $scope.croppedImg = $('#newUpload').cropper('getCroppedCanvas', { width: 500, height: 500 }).toDataURL("image/jpeg", 1.0);
        };

        //Image cropper canvas.
        $ionicModal.fromTemplateUrl('templates/img_crop.html', {
          scope: $scope,
          animation: 'slide-in-up'
        }).then(function(modal) {
          $scope.imgCrop = modal;
        });

        //Save cropped image to array.
        $scope.uploadImg = function() {
          if ($scope.croppedImg) {
        /*    let saveUpload = MeteorCameraUI.dataURIToBlob($scope.croppedImg);

            self.preview.push($scope.croppedImg);
            self.uploads.push(saveUpload);*/

            $scope.newImg = '';
            $scope.croppedImg = '';
            $scope.imgCrop.hide();
            $('#newUpload').cropper('destroy');
          }
          else {
       /*     if (Meteor.isCordova) {
              $cordovaToast.showLongBottom('Error. Please try again.');
            } else {
              toastr.error('Error. Please try again.');
            }*/
            $scope.newImg = '';
            $scope.croppedImg = '';
            $scope.imgCrop.hide();
            $('#newUpload').cropper('destroy');
          }
        };

        //Cancel image upload.
        $scope.cancelImg = function() {
          $scope.imgCrop.hide();
          $scope.newImg = '';
          $scope.croppedImg = '';
          $('#newUpload').cropper('destroy');
        };

        var handleFileSelect=function(evt) {
          var file=evt.currentTarget.files[0];
          var reader = new FileReader();
          reader.onload = function (evt) {
            $scope.$apply(function($scope){
              $scope.myImage=evt.target.result;
              //$scope.crop($scope.myImage);


$scope.newImg =  $scope.myImage;

              $scope.imgCrop.show();


              angular.element(document.querySelector('#newUpload')).on('load', function() {

                $("#newUpload").cropper({
                aspectRatio: 350/200,
                dragMode: 'move',
                rotatable: true,
                movable: true,
                responsive: true,
                toggleDragModeOnDblclick: false,
                minContainerHeight: 200,
                minCropBoxWidth: 400,
                minCropBoxHeight: 200,
                built: function(e) {
                  $scope.croppedImg = $(this).cropper('getCroppedCanvas', { width: 500, height: 500 }).toDataURL("image/jpeg", 1.0);
                },
                cropend: function(e) {
                  $scope.croppedImg = $(this).cropper('getCroppedCanvas', { width: 500, height: 500 }).toDataURL("image/jpeg", 1.0);
                }
              });

            //  var cropper = $image.data('cropper');

            });
            });

          };
          reader.readAsDataURL(file);
        };
        angular.element(document.querySelector('#fileInput')).on('change',handleFileSelect);


        $scope.$on('$ionicView.afterEnter', function (event, viewData) {
          $ionicLoading.hide();
        });

        $scope.$on('$ionicView.beforeLeave', function (event, viewData) {
          $scope.imgCrop.remove();
          $('#newUpload').cropper('destroy');
        });

        function dateFormat(date){
          var mm = date.getMonth() + 1; // getMonth() is zero-based
          var dd = date.getDate();
          var yyyy = date.getFullYear();
          return ((dd>9 ? '' : '0') + dd) + "."+((mm>9 ? '' : '0') + mm)+"."+yyyy;
        }
        $scope.date = new Date();
        $scope.date_formatted = dateFormat( $scope.date );
        var ipObj1 = {
          callback: function (val) {  //Mandatory
            $scope.date = new Date(val);
            $scope.date_formatted = dateFormat( $scope.date );
          },
          to: new Date(), //Optional
          showTodayButton: false,
          inputDate: new Date(),      //Optional
          mondayFirst: true,          //Optional
          closeOnSelect: false,       //Optional
          templateType: 'popup',      //Optional
          selectMode: 'day'           //Optional
        };

        $scope.openDatePicker = function(){
          ionicDatePicker.openDatePicker(ipObj1);
        };


      }
    ]);

})(window.angular);
