/**
 * Page controller
 */
(function (angular, undefined) {
    angular
        .module('autoinfo')

        .controller('VideoAddController',

            function videoAddController($scope, $timeout, $http, $window, $httpParamSerializer, $stateParams, $cordovaFile, $ionicLoading, videoService, $ionicPopup, $cordovaFileTransfer, $location, $q,$ionicModal,$rootScope,ionicDatePicker) {


                $scope.model = {};
                $scope.model.file = '';
                $scope.model.file_source = '';
                $scope.model.fileTrusted = '';
                $scope.model.userid = $window.localStorage.getItem(AI_USER_ID);
                $scope.model.video = '';
                $scope.model.thumb = "/img/logo-thumb.png";
                $scope.model.disabled = false;

                $scope.model.citySelected = {};
                //  $scope.model.file =  JSON.parse($window.localStorage.getItem(AI_NEW_FILE)) ;


                $scope.model.messages = MESSAGES;

                $scope.model.edit_city = false;
                $http.get('data/citiesr.json').success(function (response) {
                    //  console.log(,"city") ;
                    $scope.model.cities = response;
                    $scope.model.cities.unshift({name: " -- все регионы -- ", cities: []});
                    $scope.model.city = parseInt($window.localStorage.getItem(AI_CITY));

                    $scope.model.city_name = $window.localStorage.getItem(AI_CITY_NAME);

                });


                $scope.$on('setVideoB', function () {
                    $timeout(setVideo());
                });


                $scope.goTo = function () {
                    $state.go('app.video');
                    $location.path('app/video/', {}, {'reload': true});
                    $state.transitionTo("app.video", {}, {
                        reload: false,
                        inherit: false,
                        notify: true
                    });


                };

              function dateFormat(date){
                                     var mm = date.getMonth() + 1; // getMonth() is zero-based
                                            var dd = date.getDate();
                                            var yyyy = date.getFullYear();
                                            return ((dd>9 ? '' : '0') + dd) + "."+((mm>9 ? '' : '0') + mm)+"."+yyyy;
                                   }
                                   $scope.date = new Date();
                                   $scope.model.date_formatted = dateFormat( $scope.date );
                                   var ipObj1 = {
                                        callback: function (val) {  //Mandatory
                                          $scope.date = new Date(val);
                                          $scope.model.date_formatted = dateFormat( $scope.date );
                                        },
                                       to: new Date(), //Optional
                                        showTodayButton: false,
                                        inputDate: new Date(),      //Optional
                                        mondayFirst: true,          //Optional
                                        closeOnSelect: false,       //Optional
                                        templateType: 'popup',      //Optional
                                        selectMode: 'day'           //Optional
                                      };

                                      $scope.openDatePicker = function(){
                                        ionicDatePicker.openDatePicker(ipObj1);
                                      };



                $scope.closePlayer = function(){
                                            $scope.player = $window.document.getElementById("videoGlobal");

                                            if(typeof $scope.player !=='undefined' && $scope.player!==null){
                                            $scope.player.pause();
                                            $scope.player.currentTime = 0;
                                            }
                                       };



                        $scope.paused = function(){

                           if($scope.player.paused)$scope.player.play();
                           else $scope.player.pause();

                        };


              $scope.showImages = function(index) {
                                 $scope.activeSlide = 0;
                                 $scope.allImages = [];
                                 $scope.allImages.push(index);
                                 $rootScope.showModal('templates/image-popover.html',$scope);
                             };

                                  $scope.playVideo = function(clipSrc,poster) {
                                      $scope.clipSrc = clipSrc;
                                      $scope.poster = poster;
                                      $scope.showModal('templates/video-popover.html');
                                  };

                                  $scope.showModal = function(templateUrl) {
                                      $ionicModal.fromTemplateUrl(templateUrl, {
                                          scope: $scope,
                                          animation: 'slide-in-up'
                                      }).then(function(modal) {
                                          $scope.modal = modal;
                                          $scope.modal.show();
                                      });
                                  };

                                  // Close the modal
                                  $scope.closeModal = function() {
                                      $scope.closePlayer();
                                      $scope.modal.hide();
                                      $scope.modal.remove();
                                  };





                function saveMedia(type) {
                    return $q(function (resolve, reject) {
                        var options = optionsForType(type);

                        $cordovaCamera.getPicture(options).then(function (imageUrl) {
                            var name = imageUrl.substr(imageUrl.lastIndexOf('/') + 1);
                            var namePath = imageUrl.substr(0, imageUrl.lastIndexOf('/') + 1);
                            var newName = makeid() + name;
                            $cordovaFile.copyFile(namePath, name, cordova.file.dataDirectory, newName)
                                .then(function (info) {
                                    FileService.storeImage(newName);
                                    resolve();
                                }, function (e) {
                                    reject();
                                });
                        });
                    });
                }

                $scope.clearFile = function(){

                    $window.localStorage.setItem(AI_NEW_FILE_SOURCE,null);
                    $window.localStorage.setItem(AI_NEW_FILE, null);

                };

                function copyFile(sourcePath, type) {

                    return $q(function (resolve, reject) {


                        var sourceDirectory = sourcePath.substring(0, sourcePath.lastIndexOf('/') + 1);
                        var sourceFileName = sourcePath.substring(sourcePath.lastIndexOf('/') + 1, sourcePath.length);

                        console.log("Copying from : " + sourceDirectory + sourceFileName);
                        console.log("Copying to : " + cordova.file.dataDirectory + sourceFileName);


                        $window.localStorage.setItem(AI_NEW_FILE_SOURCE, sourcePath);
                        $window.localStorage.setItem(AI_NEW_FILE, cordova.file.dataDirectory + sourceFileName);

                        $scope.model.fileTrusted = $window.Ionic.WebView.convertFileSrc($scope.model.file);

                        if(type!==1){
                                                                               $scope.model.file = cordova.file.dataDirectory + sourceFileName;
                                                     }


                        $scope.model.file_source = cordova.file.dataDirectory + sourceFileName;

                        $cordovaFile.copyFile(sourceDirectory, sourceFileName, cordova.file.dataDirectory, sourceFileName).then(function () {
                            resolve();
                            if(type!==1){
                                                       $scope.model.file = cordova.file.dataDirectory + sourceFileName;
                             }

                          //  $scope.model.file = cordova.file.dataDirectory + sourceFileName;
                            $scope.model.file_source = cordova.file.dataDirectory + sourceFileName;
                            $window.localStorage.setItem(AI_NEW_FILE_SOURCE, sourcePath);
                            $window.localStorage.setItem(AI_NEW_FILE, $scope.model.file);

                            //   $scope.model.file = $window.Ionic.WebView.convertFileSrc($scope.model.file);
                            // if(type===4){
                            //     $scope.model.video = $scope.model.file;
                            //     $scope.model.video = $window.Ionic.WebView.convertFileSrc($scope.model.video);
                            //   //  $scope.model.file =  $scope.model.video ;
                            // }


                        }, function (error) {
                            reject();
                            console.dir(error);
                        });

                    });
                }


                function getThumbName(sourcePath) {

                    var sourceFileName = sourcePath.substring(sourcePath.lastIndexOf('/') + 1, sourcePath.length);
                    return cordova.file.dataDirectory + "/thumba_" + sourceFileName + ".jpg";

                }

                function setVideo() {
                    $scope.model.disabled = false;
                    var sourcePath = '';
                    var sourceFileName = '';
                    var thumba = '';
                    var mime = '';
                    var c = new Date();
                    $scope.model.monthes = videoService.getMonths();
                    $scope.model.cmonth = $scope.model.monthes[c.getMonth()];


                    $scope.model.ddays = [];
                    for (var i = 1; i <= 31; i++) {
                        $scope.model.ddays.push({id: i, label: i, current: $scope.model.cday === i});
                    }
                    $scope.model.cday = $scope.model.ddays[c.getDate() - 1];

                  $scope.model.date_formatted = dateFormat( $scope.date );
                    $scope.issetCity = parseInt($window.localStorage.getItem(AI_CITY), 10) > 0;
                    $scope.model.type = $window.localStorage.getItem(AI_NEW_FILE_TYPE); // foto

                    $scope.model.type = parseInt($scope.model.type);


                    if ($scope.model.type === 1) { /** PHOTO FROM LIBRARY **/
                        console.log("TYPE 1");
                        $scope.model.file = $window.localStorage.getItem(AI_NEW_FILE);


                        mime = $scope.model.file.substr($scope.model.file.lastIndexOf('.') + 1);
                        mime = mime.toLowerCase();
var filet = '';
                        //  copyFile($scope.model.file);

                        if (mime === 'mp4') {
                            //    copyFile($scope.model.file);

                            filet = window.Ionic.WebView.convertFileSrc($scope.model.file);
                           console.log("FILET", filet);
                            copyFile($scope.model.file);
                            $scope.model.file = filet;
                          //  $scope.model.file = window.Ionic.WebView.convertFileSrc($scope.model.file);

                        } else {

                            filet =  window.Ionic.WebView.convertFileSrc($scope.model.file);
                              copyFile($scope.model.file,1);

                            $scope.model.file = filet;

//$scope.model.file = $scope.model.fileTrusted;

                        }


                    }
                    if ($scope.model.type === 0) { /** VIDEO FROM LIBRARY **/
                        $scope.model.file = $window.localStorage.getItem(AI_NEW_FILE);

                        console.log("TYPE 0");
                        copyFile($scope.model.file,1);


                            $scope.model.file = window.Ionic.WebView.convertFileSrc($scope.model.file);



                    }


                    /**
                     * USE IT VIDEO OR PHOTO FROM LIBRARY
                     */
                    if ($scope.model.type === 2) { // VIDEO OR PHOTO FROM LIBRARY
                        $scope.model.file = $window.localStorage.getItem(AI_NEW_FILE);

                        console.log(" TYPE 2");

                        copyFile($scope.model.file);


                        mime = $scope.model.file.substr($scope.model.file.lastIndexOf('.') + 1);
                        mime = mime.toLowerCase();

                        if (mime === 'mp4') {
                            $scope.model.file = window.Ionic.WebView.convertFileSrc($scope.model.file);


                        } else {
                            copyFile($scope.model.file);


                            $scope.model.file = window.Ionic.WebView.convertFileSrc($scope.model.file);

                        }


                    }

                    /**
                     * USE IT PHOTO FROM CAMERA
                     */
                    if ($scope.model.type === 3) { // PHOTO FROM CAMERA


                        console.log(" TYPE 3 ");
                        $scope.model.file = $window.localStorage.getItem(AI_NEW_FILE);


                        copyFile($scope.model.file);


                        $scope.model.file = window.Ionic.WebView.convertFileSrc($scope.model.file);

                    }


                    /**
                     * USE IT VIDEO FROM CAPTURE
                     */

                    if ($scope.model.type === 4) {  // VIDEO FROM CAPTURE
                        $scope.model.type = 0;
                        console.log("TYPE 4");
                        console.log("CAPTURE SUCCESS");
                        var jfile = JSON.parse($window.localStorage.getItem(AI_NEW_FILE));
                        //  captureSuccess($scope.model.file);
                        //($scope.model.file);


                        if (typeof jfile[0] === 'undefined' || jfile[0] === null) return true;
                        $scope.model.file = jfile[0].fullPath;
                        copyFile($scope.model.file).then(function () {

                            $scope.model.file = $window.Ionic.WebView.convertFileSrc($scope.model.file);


                        });


                    }


                }

                $scope.$on('$locationChangeStart', function (ev, state) {

                    $timeout(setVideo());

                });

                $scope.$on('$stateChangeStart', function (ev, state) {

                    $timeout(setVideo());

                });


                $scope.setPhoto = function (url) {
                    console.log(url, 'SET PHOTO');
                    alert(url);
                    var image = document.getElementById('myImage');
                    image.src = url;
                };


                function captureSuccess(mediaFiles) {
                    var i, len;
                    // return  true;
                    //  console.log(mediaFiles,"mediaFiles");

                    if (typeof mediaFiles === 'undefined' || mediaFiles === null) return true;
                    console.log("START");
                    for (i = 0, len = mediaFiles.length; i < len; i++) {
                        var mediaFile = mediaFiles[i];

                        //  console.log(mediaFile.localURL,"mediaFile.fullPath333333333");
                        copyFile(mediaFile.fullPath, 4);


                        return true;


                    }
                }


                String.prototype.replaceAt = function (index, replacement) {
                    if (this.length < index) return;
                    return this.substr(0, index) + replacement + this.substr(index + replacement.length);
                };


                function readFile(pathToFile) {
                    resolveLocalFileSystemURL(pathToFile, function (fileEntry) {
                        fileEntry.file(function (file) {
                            var reader = new FileReader();
                            reader.onloadend = function (event) {
                                console.log(event);
                            };
                            reader.readAsDataURL(file);
                        });
                    });
                }


                $scope.changeDate = function () {


                };
                $scope.submit_ = function () {

                    console.error("test", "SUBMIT1");
                    $scope.model.disabled = 1;

                    var data = {};
                    data.file = $window.localStorage.getItem(AI_NEW_FILE_SOURCE);
                    console.error(data.file, "AI_NEW_FILE_SOURCE");

                    var city = 0;
                    if (typeof $scope.model.citySelected === "undefined" || typeof $scope.model.citySelected.city_id === 'undefined') {
                        city = parseInt($window.localStorage.getItem(AI_CITY));
                    }else{
                        city = parseInt($scope.model.citySelected.city_id);
                    }


                    console.error("test", "SUBMIT2");

                    data.city = city;

                    data.cday = $scope.model.cday.id;
                    data.cmonth = $scope.model.cmonth.id;

                    data.uid = $window.localStorage.getItem(AI_USER_ID);
                  data.date_formatted =  $scope.model.date_formatted;

                    console.error("test", "SUBMIT3");
                    var nick = $window.localStorage.getItem(AI_USER_NAME);

                    var no = JSON.parse($window.localStorage.getItem(AI_ANUMBERS))[0].num;


                    $scope.model.no = no;


                    data.nick = nick;
                    data.no = no;

                    var key = new Date().getTime();

                    console.error("test", "SUBMIT4");

                    //    var fp =  videoService.uploadFiles1(data, data.file, key, 1, MGC_API+"upload_video");


                    var item = data.file;

                    console.error(item, "SUBMIT5");
                    var mime = item.substr(item.lastIndexOf('.') + 1);
                    mime = mime.toLowerCase();
                    console.error("test", "SUBMIT6");


                    var ext = '.jpg';
                    if (mime === 'mp4') {
                        mime = "video/mp4";
                        ext = '.mp4';
                        data.file_type = 0; // video
                    } else if (mime === 'avi') {
                        mime = "video/avi";
                        ext = '.avi';
                        data.file_type = 0; // video
                    } else if (mime === 'png') {
                        mime = "image/png";
                        ext = '.png';
                        data.file_type = 1; // photo
                    } else {
                        mime = "image/jpeg";
                        ext = '.jpg';
                        data.file_type = 1; // photo
                    }


                    var params = data;
                    params.key = key;
                    params.len = 1;


                    var options = {
                        fileKey: "file",
                        fileName: 'file' + ext,
                        chunkedMode: false,
                        mimeType: mime
                    };
                    console.error("test", "SUBMIT7");
                    //  params.file=
                    options.params = params;

                    //  console.error(apiUrl,"APIURL");
// console.log(cordova.file.externalRootDirectory,"cordova.file.externalRootDirectory");
//
//                     window.resolveLocalFileSystemURL(item,function(item){
//
//                       //  console.error(item.toURL(),'ERRRRORRRAA');
//
//                     });

//
// function gotFS(fileSystem) {
//                        console.log("got filesystem: "+fileSystem.name); // displays "persistent"
//                        console.log(fileSystem.root.toURL); // displays "/"
//                        window.rootFS = fileSystem.root;
//                    }
//
//
//                     window.requestFileSystem  = window.requestFileSystem || window.webkitRequestFileSystem;
//                        window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, gotFS, function(){
//                            console.log("error requesting LocalFileSystem");
//                        });

                    $scope.downloadProgress = 0;

                    // $ionicLoading.show({
                    //     template: '<div class="loader">Загрузка ... {{downloadProgress}}% <ion-spinner class="spinner-energized"></ion-spinner></div>'
                    // });


                    var fp = $cordovaFileTransfer.upload(encodeURI(MGC_API + "upload_video"), (item), options);


                    console.error("test", "SUBMIT44");


                    fp.then(function (value) {
                        $scope.model.disabled = 200;
                        console.error("test", "SUBMIT5");
                        var response = JSON.parse(value.response);
                        $scope.key = response.end;
                        $scope.key1 = response;
                        console.error(JSON.stringify(response));
                        $ionicLoading.hide();
                        if (typeof response.end != "undefined" && response.end) {
                            // var alertPopup = $ionicPopup.alert({
                            //     title: "Успешно",
                            //     template: "Загружено!"
                            // });
                            $scope.model.disabled = 200;
                            $scope.model.ok = 'Загружено!';
                            $scope.clearFile();
                            $rootScope.$broadcast('loadDataV');

                            $scope.goTo();
                            /* return false;*/
                        }
                        $messages = response.data.message;
                        $title = response.data.title;
                    }, function (response) {
                        console.error("test", "SUBMIT6");
                        $scope.model.disabled = 100;
                        ionicLoading.hide();
                        var alertPopup = $ionicPopup.alert({
                            title: "Ошибка",
                            template: "Ошибка загрузки файла попробуйте еще!",
                        });
                        $scope.model.disabled = false;
                        $messages = response.statusText;
                        $title = response.status;
                        $scope.clearFile();
                        console.error(JSON.stringify(response));
                        $scope.goTo();
                        $scope.start();
                    }, function (progress) {
                        $timeout(function () {
                            $scope.downloadProgress = (progress.loaded / progress.total) * 100;
                        });
                    }).finally(function () {
                        $scope.model.disabled = 200;
                        $rootScope.$broadcast('loadDataV');
                        console.error("test", "SUBMIT7");
                        // event done, hidden animation loading
                        $scope.clearFile();
                        $scope.start();
                        $ionicLoading.hide();
                        $scope.goTo();
                    });


                    //  });


                };


// captureSuccess($scope.model.file);

                console.log($scope.model.file, "SET VIDEO FILE XXX");

            });

})(window.angular);
