/**
 * Items service
 */
(function(angular, undefined) {
angular
	.module('autoinfo')

	.service('itemsService', [
		'$http',
	'$window',
		'sharedObjects',
		function ($http,  $window, sharedObjects) {
			'use strict';

			function _prepItemsData(data) {
				var preparedData = [];

				for (var index = 0, dLength = data.length; index < dLength; index++) {
					preparedData.push(_transformItemData(data[index]));
				}

				return preparedData;
			}

			function _transformItemData(data,who) {
				console.log(	'data' );
				console.log(	data );


				try {


				var img = data.imgs;
				}
				catch (e) {
					var imgs = {};
				var img = '';
				}



				return {

					id: data.msg_id,
					title: data.msg_header,
					source: '',
					featured: 1,
					date: data.msg_timestamp,
					img: img,
					imgs: imgs,
					description:  data.msg_full  ,
					short: data.msg_short ,
          button: typeof data.btn!=='undefined'?data.btn:'',
					category: data.type_id,
          type_name: data.type_name,
					link: data.msg_id,
					video_files:data.video_files,
					video:data.video_files_out
				};
			}

			function getItems(params) {
				return $http.get(MGC_NEWS_ITEMS_URL+sharedObjects.generateSearchParams(params)+"&city="+parseInt($window.localStorage.getItem(AI_CITY)))
					.then(function(items) {
						return _prepItemsData(items.data);
					});
			}

			function getItemById(itemId) {
				return $http.get(MGC_NEWS_ITEMS_URL+"/"+(itemId))
					.then(function(item) {
						return _transformItemData(item.data);
					});
			}

			return {
				  getItems: getItems,
				getItemById: getItemById
			};
		}
	]);

})(window.angular);
