/**
 * Pages service
 */
(function(angular, undefined) {
angular
	.module('autoinfo')

	.service('pagesService', [
		'$http',
    '$window',
		function ($http,$window) {
			'use strict';

			function _transformPageData(data) {
				return {
					id: data.id,
					title: data.title,
          compile: data.compile,
					app_title: data.app_title,
					description: data.text
				};
			}

			function getPageById(pageId) {
				return $http.get(MGC_API + 'pages/'+pageId)
					.then(function(page) {
            $window.localStorage.setItem("__AI_PAGE_CACHE_"+pageId,JSON.stringify(page.data));
						return _transformPageData(page.data);
					},function(){
           var data =  JSON.parse($window.localStorage.getItem("__AI_PAGE_CACHE_"+pageId));
            return _transformPageData(data);


          });
			}

			return {
				getPageById: getPageById
			};
		}
	]);

})(window.angular);
