/**
 * Categories service
 */
(function(angular, undefined) {
angular
	.module('autoinfo')

	.service('pcategoriesService', [
		'$http',
		'$window',
		function ($http,$window) {
			'use strict';

			function prepCategoriesData(data) {
				var preparedData = [];

				for (var index = 0, dLength = data.length; index < dLength; index++) {
					if (data[index].slug !== 'uncategorized') {
						preparedData.push(data[index]);
					}
				}

				return preparedData;
			}

			function getCategories() {
				return $http.get(MGC_PARTNER_CATS_URL+"?city="+parseInt($window.localStorage.getItem(AI_CITY)))
					.then(function(response) {
						return prepCategoriesData(response.data);
					});
			}

			function getMainPage() {
				//console.log("getMainPage");
				return $http.get(MGC_MAIN_URL)
					.then(function(response) {
						return (response.data);
					});
			}

			function getCategory(catId) {
				return $http.get(MGC_PARTNER_CATS_URL + "/"+catId)
					.then(function(response) {
						return response.data;
					});
			}

			return {
				getMainPage:getMainPage,
				getCategories: getCategories,
				getCategory: getCategory
			};
		}
	]);

})(window.angular);
