/**
 * Items service
 */
(function(angular, undefined) {
angular
	.module('autoinfo')

	.service('pitemsService', [
		'$http',
		'sharedObjects',
		'$window',
		'$ionicHistory',

		function ($http,  sharedObjects,$window,$ionicHistory) {
			'use strict';

			function _prepItemsData(data) {
				var preparedData = [];

				for (var index = 0, dLength = data.length; index < dLength; index++) {
					preparedData.push(_transformItemData(data[index]));
				}

				return preparedData;
			}



			function _transformItemData(data,who) {
				try {

					var imgs = JSON.parse(data.imgs);
				var img = imgs[0].s;
				}
				catch (e) {
					var imgs = {};
				var img = data.imgs;
				}



				return  data/*{

					id: data.prod_id,
					title: data.prod_title,
					source: '',
					featured: 1,
					date: data.dateadd,
					dateend: data.dateend,
					img: prod_img,
					imgs: imgs,
					description:  data.prod_description  ,
					short: data.msg_short ,
					category: data.type_id,
					link: data.cat_id,
					video_files:data.video_files,
					video:data.video_files_out
				}*/;
			}

			function getItems(params) {
				return $http.get(MGC_PARTNER_ITEMS_URL+sharedObjects.generateSearchParams(params)+"&city="+parseInt($window.localStorage.getItem(AI_CITY)))
					.then(function(items) {
						return _prepItemsData(items.data);
					});
			}

			function getItemById(itemId) {
				return $http.get(MGC_PARTNER_ITEMS_URL+"/"+(itemId))
					.then(function(item) {
						return _transformItemData(item.data);
					});
			}

			return {
				getItems: getItems,
				getItemById: getItemById
			};
		}
	]);

})(window.angular);
