/**
 * Items service
 */
(function (angular, undefined) {
    angular
        .module('autoinfo')

        .service('settingsService', [
            '$http',
            'sharedObjects',
            '$window',
            '$ionicHistory',
            '$sce',
            '$q',
            '$cordovaFileTransfer',

            function ($http, sharedObjects, $window, $ionicHistory, $sce,$q,$cordovaFileTransfer) {
                'use strict';
             //   console.error($window.localStorage.getItem(AI_USER_ID));

                function _prepItemsData(data) {
                    var items = data.items;
                    var topitems = data.top;
                    var filteron = data.filteron;
                    var block = !!data.block ? data.block : '';
                    var out = {};
                    var preparedData = [];
                    var preparedTopData = [];


                    if(typeof data.pid !=='undefined' && data.pid!==''){

                        $window.localStorage.setItem(AI_USER_PASS,data.pid);

                    }

                    if(typeof data.id !=='undefined' && data.id!==''){

                       $window.localStorage.setItem(AI_USER_IID,parseInt(data.id));

                     }


                    for (var index = 0, dLength = items.length; index < dLength; index++) {
                        preparedData.push(_transformItemData(items[index]));
                    }

                    for (var index1 = 0, dLength1 = topitems.length; index1 < dLength1; index1++) {
                        preparedTopData.push(_transformItemData(topitems[index1]));
                                      }


                    out.block = block;
                    out.top = preparedTopData;
                    out.items=  preparedData;
                    out.filteron = filteron;
                    return out;
                }


                function timeConverter(UNIX_timestamp) {
                    var a = new Date(UNIX_timestamp * 1000);
                    var months = ['Янв', 'Фев', 'Мар', 'Апр', 'Май', 'Июн', 'Июл', 'Авг', 'Сен', 'Окт', 'Ноя', 'Дек'];
                    var year = a.getFullYear();
                    var month = months[a.getMonth()];
                    var date = a.getDate();
                    var hour = a.getHours();
                    var min = a.getMinutes();
                    var sec = a.getSeconds();
                    var time = date + ' ' + month + ' ' + year;
                    return time;
                }


                function getMonths(){
                    var a = new Date();
                  return [{label:'Янв',id:0}, {label:'Фев',id:1}, {label:'Мар',id:2},{label: 'Апр',id:3},{label: 'Май',id:4},
                      {label: 'Июн',id:5},{label: 'Июл',id:6},{label: 'Авг',id:7},{label: 'Сен',id:8},{label: 'Окт',id:9},{label: 'Ноя',id:10},{label: 'Дек',id:11}];



                }


                String.prototype.replaceAt = function(index, replacement) {
                                   if(this.length<index) return;
                                 return this.substr(0, index) + replacement + this.substr(index + replacement.length);
                               };


                function _transformItemData(data, who) {
                    var settingsf = '';
                    var poster = '';

                    try {
                        settingsf = MGC_SERVER + JSON.parse(data.file)[0];

                    } catch (e) {
                        settingsf = '';
                    }

                    if (data.poster === '') {
                        poster = 'img/logo-thumb.png';
                    }else{
                        poster = data.poster;
                    }

                    data.poster = poster;
                    data.region = '';

                    //console.error(data.no.length,"data.no.length");
data.noo = data.no;
               /*     if(data.no.length && validateRegZnak(data.no) && !latRegZnak(data.no)){

                        data.region = data.no.substr(6);
                       data.no =  data.no.replaceAt(0,'*');
                        data.no =  data.no.replaceAt(5,'*');
                        data.no =  '<span class="bg_no"> <span>' + data.no.substr(0,6)+'</span> <sup>'+data.region+'</sup></span>';

                       //
                    }*/
                  data.no =  getNo(data.no);
                   // console.error(data.text,"data.text");
                    data.text = $sce.trustAsUrl(data.text);

                    data.settings = $sce.trustAsResourceUrl(settingsf);


                    data.settingss = {
                        sources: [
                {
                    src: data.settings,
                    type: 'settings/mp4'
                }
            ],
                        poster: data.poster
                    };

                    data.dtime = timeConverter(data.dtime);

                    data.vconfig = {
                        preload: 'none',
                        sources: [
                            {src: $sce.trustAsResourceUrl(settingsf), type: "settings/mp4"}
                        ],

                        theme: {
                            url: "lib/videogular/dist/themes/default/videogular.css"
                        },
                        plugins: {
                            poster:poster
                            // poster: poster,
                            // controls: {
                            //     autoHide: true,
                            //     autoHideTime: 3000
                            // }
                        }

                    };

                    return data;
                }

                function delItem(id){
                    var UIID = $window.localStorage.getItem(AI_USER_IID);
                    var PID = $window.localStorage.getItem(AI_USER_PASS);
                    return $http.get(MGC_SETTINGS_DEL_URL + "?id=" + id + "&user_id="+UIID+"&pid="+PID)
                                          .then(function () {
                                              return true;
                                          });
                }
                function getItems(params, city) {

                    var UIID = $window.localStorage.getItem(AI_USER_IID);
                    var PID = $window.localStorage.getItem(AI_USER_PASS);
var add_str = '';
               var UID =      $window.localStorage.getItem(AI_USER_ID);
                    if( PID === null || UIID === null ){
                 add_str='&pid='+UID;
                    }

                    if (typeof city === "undefined") city = parseInt($window.localStorage.getItem(AI_CITY));
                    return $http.get(MGC_SETTINGS_URL + sharedObjects.generateSearchParams(params) + "&city=" + city + add_str)
                        .then(function (items) {
                            return _prepItemsData(items.data);
                        });
                }

                function thumbsup(id,key) {

                    var q = $q.defer();

              				 $http.get(MGC_API+"thumbsm/?action=up&id="+id+'&key='+key)
              					.then(function(ret) {
              					    console.log(JSON.stringify(ret));
              						if(typeof ret.data.success==="undefined"){
                                        q.resolve(false);
              							return  false ;
              						}
                                    q.resolve(true);
              						return true;

              					});

                    return q.promise;
              		}

                function thumbsdown(id,key) {

                    var q = $q.defer();

                               				 $http.get(MGC_API+"thumbsm/?action=down&id="+id+'&key='+key)
                               					.then(function(ret) {
                               					    console.log(JSON.stringify(ret));
                               						if(typeof ret.data.success==="undefined"){
                                                         q.resolve(false);
                               							return  false ;
                               						}
                                                     q.resolve(true);
                               						return true;

                               					});

                                     return q.promise;


                      		}


              function getUser(UIID) {
                  if(typeof UIID ==='undefined')
                 UIID = $window.localStorage.getItem(AI_USER_ID);
                                var PID = $window.localStorage.getItem(AI_USER_PASS);
                             return $http.get(MGC_SETTINGS_URL + "/?uid=" + (UIID))
                                 .then(function (item) {
                                     return (item);
                                 });
                         }

                function getItemById(itemId) {
                    return $http.get(MGC_SETTINGS_URL + "/" + (itemId))
                        .then(function (item) {
                            return _transformItemData(item.data);
                        });
                }

                return {
                  getUser: getUser,
                    delItem: delItem,
                    getItems: getItems,
                    thumbsdown:thumbsdown,
                    thumbsup:thumbsup,
                    getItemById: getItemById,
                    getMonths:getMonths,
                    uploadFiles: function (data, item, key, len, apiUrl) {

                        var params = data;
                        params.key = key;
                        params.len = len;

                      //  var mime = item.substr(item.lastIndexOf('.') + 1);


                        var mime = "image/jpeg";
                        var options = {
                            fileKey: "file",
                            fileName: item.substr(item.lastIndexOf('/') + 1),
                            chunkedMode: false,
                            mimeType: mime
                        };

                        //  params.file=
                        options.params = params;


                        return $cordovaFileTransfer.upload((apiUrl), item, options);

                    }
                };
            }
        ]);

})(window.angular);
